clear

* Import and clean stock market price data
******************************************

import excel "Data\Source\8-portefeuille-cote-ape.xls", sheet("DATA") cellrange(B7:P568) allstring firstrow clear

ren B date_text
replace date_text = trim(date_text) // Some dates contain leading blanks

gen date =  date(date_text,"MDY",2050)
format date %td
drop if date == .

drop FCHI // This is not a listed firm but the code of CAC 40 stock market index

foreach var of varlist ADPPA-TCFPPA{
ren `var' price`var'
}
*

reshape long price, i(date) j(firm) string

replace firm = substr(firm,1,length(firm)-2)
tab firm

save "Data/Temp/stocks", replace

* Import and clean state's shares
*********************************

import excel "Data\Source\8-portefeuille-cote-ape.xls", sheet("DATA") cellrange(T7:AG585) allstring firstrow clear

ren T date_text
replace date_text = trim(date_text) // Some dates contain leading blanks

duplicates tag date_text, gen(A)
bro if A == 1 | A[_n+1] == 1 | A[_n-1] == 1 // Visual inspection of the data inform us that date_text is "3/25/2013" on line 140 while it should be "9/25/2013" (September instead of March)
replace date_text = "9/25/2013" if date_text == "3/25/2013" & _n == 140
drop A

gen date =  date(date_text,"MDY",2050)
format date %td
drop if date == .

foreach var of varlist ADPPA-TCFPPA{
ren `var' shares`var'
}
*

reshape long shares, i(date) j(firm) string

replace firm = substr(firm,1,length(firm)-2)
tab firm

merge 1:1 firm date using "Data/Temp/stocks"
drop _merge
erase "Data/Temp/stocks.dta"

destring shares price, replace

* Saving
********

save "Data/Final/state_stock", replace
