clear

use "Data/Final/state_stock", clear

sort firm date
gen diff = shares[_n] - shares[_n-1] if firm[_n] == firm[_n-1]

gen buy_sell = -1 if diff < 0
replace buy_sell = 1 if diff > 0 & diff != .

label define buy_sell -1 "Sale" 1 "Purchase"
label values buy_sell buy_sell

tab buy_sell // 10 (7) days where the number of shares held by the state increases (decreases)

* List of sales by French state
list firm date if buy_sell == -1

* List of purchases by French state
list firm date if buy_sell == 1

* Total value of French state's protfolio on January 30, 2014 : 79,128 billion euro
gen value = shares*price
egen portfolio = sum(value), by(date)
keep if date == date("30/1/2014","DMY")
di %18.0gc portfolio[1] " euros"
